/*! anyboard 2015-09-25 */
"use strict";var AnyBoard=AnyBoard||{};"undefined"!=typeof module&&(module.exports=AnyBoard),AnyBoard.Drivers={drivers:{}},AnyBoard.Drivers.get=function(a){return this.drivers[a]},AnyBoard.Drivers.getCompatibleDriver=function(a,b){for(var c in AnyBoard.Drivers.drivers)if(AnyBoard.Drivers.drivers.hasOwnProperty(c)){var d=AnyBoard.Drivers.drivers[c];if(!("string"==typeof d.type&&a!==d.type||d.type instanceof Array&&-1===d.type.indexOf(a)))if(d.compatibility instanceof Array){for(var e in d.compatibility)if(d.compatibility.hasOwnProperty(e)&&AnyBoard.Utils.isEqual(b,d.compatibility[e]))return d}else if(AnyBoard.Utils.isEqual(b,d.compatibility))return d}return void 0},AnyBoard.Drivers._add=function(a){return a.name?(this.drivers[a.name]&&AnyBoard.Logger.warn("Driver with name + "+a.name+" already existed. Overwriting",this),void(this.drivers[a.name]=a)):void AnyBoard.Logger.warn("Attempted to add driver without name. Driver will be ignored.",this)},AnyBoard.Drivers.toString=function(){return"AnyBoard.Drivers (driverManager)"},AnyBoard.Driver=function(a){a.name&&a.description&&a.version&&a.type&&a.compatibility||AnyBoard.Logger.warn("Attempted to add driver without necessary options (name, description, version, type, compatibility). Driver will be ignored.",this),this.name=a.name,this.description=a.description,this.dependencies=a.dependencies,this.version=a.version,this.date=a.date,this.type=a.type,this.compatibility=a.compatibility,this.properties=a,AnyBoard.Logger.debug("Loaded Driver "+a.name,this),AnyBoard.Drivers._add(this)},AnyBoard.Driver.prototype.toString=function(){return"Driver: "+this.name},AnyBoard.Deck=function(a,b){AnyBoard.Logger.debug("Adding new Deck "+a),this.name=a,this.cards=[],this.pile=[],this.usedPile=[],this.autoUsedRefill=!0,this.autoNewRefill=!1,this.playListeners=[],this.drawListeners=[],AnyBoard.Deck.all[this.name]?AnyBoard.Logger.warn("Deck with name "+this.name+" already exists. Old deck will no longer be available through AnyBoard.Deck.get",this):AnyBoard.Deck.all[this.name]=this,this._initiate(b)},AnyBoard.Deck.all={},AnyBoard.Deck.get=function(a){return AnyBoard.Deck.all[a]},AnyBoard.Deck.prototype.shuffle=function(){for(var a,b,c=this.pile.length;c;a=Math.floor(Math.random()*c),b=this.pile[--c],this.pile[c]=this.pile[a],this.pile[a]=b);},AnyBoard.Deck.prototype._initiate=function(a){a.hasOwnProperty("autoNewRefill")&&(this.autoNewRefill=a.autoNewRefill),a.hasOwnProperty("autoUsedRefill")&&(this.autoUsedRefill=a.autoUsedRefill);for(var b,c=0;c<a.cards.length;c++){b=new AnyBoard.Card(this,a.cards[c]);for(var d=0;d<b.amount;d++)this.cards.push(b)}this.refill(!0)},AnyBoard.Deck.prototype.refill=function(a){var b=this.pile.slice();a?this.pile=this.cards.slice():this.pile=this.usedPile.slice(),0===this.pile.length?AnyBoard.Logger.debug("Can't refill Deck. No cards to refill with.",this):AnyBoard.Logger.debug("Refilling Deck with "+this),this.shuffle(),this.pile.concat(b),a||(this.usedPile=[])},AnyBoard.Deck.prototype._draw=function(a,b){this.pile.length<1&&(this.autoNewRefill?this.refill(!0):this.autoUsedRefill&&this.refill(!1));var c=this.pile.pop();if(c){for(var d in this.drawListeners)this.drawListeners.hasOwnProperty(d)&&this.drawListeners[d](c,a,b);for(var e in c.drawListeners)c.drawListeners.hasOwnProperty(e)&&c.drawListeners[e](c,a,b)}return c},AnyBoard.Deck.prototype.onPlay=function(a){AnyBoard.Logger.debug("Adds a new playListener",this),this.playListeners.push(a)},AnyBoard.Deck.prototype.onDraw=function(a){AnyBoard.Logger.debug("Adds function to drawListener of deck "+this.name),this.drawListeners.push(a)},AnyBoard.Deck.prototype.toString=function(){return"Deck: "+this.name},AnyBoard.Card=function(a,b){AnyBoard.Logger.debug("Adding new Card "+b.title),this.id=AnyBoard.Card.AUTO_INC(),this.title=b.title,this.description=b.description,this.color=b.color||null,this.category=b.category||null,this.value=b.value||null,this.type=b.type||null,this.amount=b.amount||1,this.playListeners=[],this.drawListeners=[],this.properties=b,this.deck=a,AnyBoard.Card.all[this.id]=this,AnyBoard.Card.allTitle[this.title]&&AnyBoard.Logger.warn("Card with title "+this.title+" already exists. Old card will no longer be available through AnyBoard.Card.get",this),AnyBoard.Card.allTitle[this.title]=this},AnyBoard.Card.COUNTER=0,AnyBoard.Card.AUTO_INC=function(){return++AnyBoard.Card.COUNTER},AnyBoard.Card.all={},AnyBoard.Card.allTitle={},AnyBoard.Card.get=function(a){return isNaN(a)?AnyBoard.Card.allTitle[a]:AnyBoard.Card.all[a]},AnyBoard.Card.prototype.onPlay=function(a){AnyBoard.Logger.debug("Adds a new playListener",this),this.playListeners.push(a)},AnyBoard.Card.prototype.onDraw=function(a){AnyBoard.Logger.debug("Adds a new drawListener",this),this.drawListeners.push(a)},AnyBoard.Card.prototype._play=function(a,b){this.deck.usedPile.push(this);for(var c in this.playListeners)this.playListeners.hasOwnProperty(c)&&this.playListeners[c](this,a,b);for(var d in this.deck.playListeners)this.deck.playListeners.hasOwnProperty(d)&&this.deck.playListeners[d](this,a,b)},AnyBoard.Card.prototype.toString=function(){return"Card: "+this.title+", id: "+this.id},AnyBoard.Dice=function(a,b){this.eyes=a||6,this.numOfDice=b||1},AnyBoard.Dice.prototype.roll=function(){for(var a=0,b=0;b<this.numOfDice;b++)a+=Math.floor(Math.random()*this.eyes)+1;return a},AnyBoard.Dice.prototype.rollEach=function(){for(var a=[],b=0;b<this.numOfDice;b++)a.push(Math.floor(Math.random()*this.eyes)+1);return a},AnyBoard.Player=function(a,b){AnyBoard.Logger.debug("Adding new Player "+a),b=b||{},this.color=b.color,this.name=a,this.hand=new AnyBoard.Hand(this),this.faction=b.faction,this["class"]=b["class"],this.bank=new AnyBoard.ResourceSet,this.properties=b,AnyBoard.Player.all[this.name]&&AnyBoard.Logger.warn("Player with name "+this.name+" already exists. Old player will no longer be available through AnyBoard.Player.get",this),AnyBoard.Player.all[this.name]=this},AnyBoard.Player.all={},AnyBoard.Player.get=function(a){return AnyBoard.Player.all[a]},AnyBoard.Player.prototype.pay=function(a,b){return this.bank.contains(a)?(b&&b.recieve(a),AnyBoard.Logger.debug(""+this.name+" paid "+a.resources,this),this.bank.subtract(a),!0):(AnyBoard.Logger.debug(""+this.name+" does not have sufficient resources to pay "+a.resources,this),!1)},AnyBoard.Player.prototype.trade=function(a,b,c){var d=a.similarities(b);return b.subtract(d),a.subtract(d),this.bank.contains(a)?b&&c&&!c.bank.contains(b)?(AnyBoard.Logger.debug(""+c.name+" does not have sufficient resources to trade "+b.resources,this),!1):(c?c.pay(b,this):this.receive(b),this.pay(a,c),!0):(AnyBoard.Logger.debug(""+this.name+" does not have sufficient resources to trade "+a.resources,this),!1)},AnyBoard.Player.prototype.recieve=function(a){AnyBoard.Logger.debug("Received "+a.resources,this),this.bank.add(a)},AnyBoard.Player.prototype.draw=function(a,b){var c=a._draw(this,b);return c?(this.hand._add(c),AnyBoard.Logger.debug("Drew "+c+" from deck "+a,this)):AnyBoard.Logger.debug("Can't draw from empty deck "+a,this),c},AnyBoard.Player.prototype.play=function(a,b){return this.hand.has(a)?(AnyBoard.Logger.debug("Plays card "+a.title,this),this.hand.cards[a.id]-=1,a._play(this,b),!0):!1},AnyBoard.Player.prototype.toString=function(){return"Player: "+this.name},AnyBoard.Hand=function(a,b){AnyBoard.Logger.debug("Adding new Hand to player "+a.name),this.cards={},this.player=a,this.properties=b},AnyBoard.Hand.prototype.has=function(a,b){return b=b||1,this.cards[a.id]&&this.cards[a.id]>=b?!0:!1},AnyBoard.Hand.prototype._add=function(a){this.cards[a.id]||(this.cards[a.id]=0),this.cards[a.id]+=1},AnyBoard.Hand.prototype.discardHand=function(){for(var a in this.cards)if(this.cards.hasOwnProperty(a))for(var b=0;b<this.cards[a];)this.discardCard(AnyBoard.Card.get(a))},AnyBoard.Hand.prototype.discardCard=function(a){AnyBoard.Logger.debug("Discarding card "+a,this.player),this.cards[a.id]&&0!==this.cards[a.id]&&(a.deck.usedPile.push(a),this.cards[a.id]-=1)},AnyBoard.Hand.prototype.toString=function(){return"Hand ("+(this.player?this.player.name:"no one")+")"},AnyBoard.Resource=function(a,b){return AnyBoard.Logger.debug("Adding new Resource "+a),AnyBoard.Resource.all[this.name]?void AnyBoard.Logger.error("Resource with name "+this.name+" already exists",this):(this.name=a,this.properties=b,void(AnyBoard.Resource.all[this.name]=this))},AnyBoard.Resource.all={},AnyBoard.Resource.get=function(a){return AnyBoard.Resource.all[a]},AnyBoard.ResourceSet=function(a,b){AnyBoard.Logger.debug("Adding new ResourceSet (allowNegative: "+b+")"),this.resources={};for(var c in a)a.hasOwnProperty(c)&&("string"==typeof c?AnyBoard.Resource.get(c)?this.resources[c]=a[c]:AnyBoard.Logger.warn("Attempting to create ResourceSet with non-existant resource "+c+". Resource ignored."):c instanceof AnyBoard.Resource&&(this.resources[c.name]=a[c]));this.allowNegative=b||!1},AnyBoard.ResourceSet.prototype.contains=function(a){for(var b in a.resources)if(a.resources.hasOwnProperty(b)&&a.resources[b]>0&&(!this.resources.hasOwnProperty(b)||this.resources[b]<a.resources[b]))return!1;return!0},AnyBoard.ResourceSet.prototype.add=function(a){for(var b in a.resources)a.resources.hasOwnProperty(b)&&(this.resources.hasOwnProperty(b)||(this.resources[b]=0),this.resources[b]+=a.resources[b])},AnyBoard.ResourceSet.prototype.subtract=function(a){if(!this.allowNegative&&!this.contains(a))return!1;for(var b in a.resources)a.resources.hasOwnProperty(b)&&(this.resources.hasOwnProperty(b)||(this.resources[b]=0),this.resources[b]-=a.resources[b]);return!0},AnyBoard.ResourceSet.prototype.similarities=function(a){var b={};for(var c in a.resources)a.resources.hasOwnProperty(c)&&this.resources.hasOwnProperty(c)&&(b[c]=Math.min(this.resources[c],a.resources[c]));return b},AnyBoard.TokenManager={tokens:{},driver:null,listeners:{tokenEvent:{},onceTokenEvent:{},tokenTokenEvent:{},onceTokenTokenEvent:{},tokenConstraintEvent:{},onceTokenConstraintEvent:{}}},AnyBoard.TokenManager.setDriver=function(a){a.connect&&"function"==typeof a.connect||AnyBoard.Logger.warn("Could not find connect() on given driver.",this),a.disconnect&&"function"==typeof a.disconnect||AnyBoard.Logger.warn("Could not find disconnect() on given driver",this),a.scan&&"function"==typeof a.scan||AnyBoard.Logger.warn("Could not find scan() on given driver",this),(!this.driver||a.connect&&"function"==typeof a.connect&&a.disconnect&&"function"==typeof a.disconnect&&a.scan&&"function"==typeof a.scan)&&(this.driver=a)},AnyBoard.TokenManager.scan=function(a,b,c){this.driver.scan(function(b){AnyBoard.TokenManager.tokens[b.address]=b,a&&a(b)},b,c)},AnyBoard.TokenManager.get=function(a){return this.tokens[a]},AnyBoard.TokenManager.onTokenTokenEvent=function(a,b){AnyBoard.Logger.debug("Added listener to TT-event: "+a,this),this.listeners.tokenTokenEvent[a]||(this.listeners.tokenTokenEvent[a]=[]),this.listeners.tokenTokenEvent[a].push(b)},AnyBoard.TokenManager.onceTokenTokenEvent=function(a,b){AnyBoard.Logger.debug("Added onceListener to TT-event: "+a,this),this.listeners.onceTokenTokenEvent[a]||(this.listeners.onceTokenTokenEvent[a]=[]),this.listeners.onceTokenTokenEvent[a].push(b)},AnyBoard.TokenManager.onTokenConstraintEvent=function(a,b){AnyBoard.Logger.debug("Added listener to TC-event: "+a,this),this.listeners.tokenConstraintEvent[a]||(this.listeners.tokenConstraintEvent[a]=[]),this.listeners.tokenConstraintEvent[a].push(b)},AnyBoard.TokenManager.onceTokenConstraintEvent=function(a,b){AnyBoard.Logger.debug("Added onceListener to TC-event: "+a,this),this.listeners.onceTokenConstraintEvent[a]||(this.listeners.onceTokenConstraintEvent[a]=[]),this.listeners.onceTokenConstraintEvent[a].push(b)},AnyBoard.TokenManager.onTokenEvent=function(a,b){AnyBoard.Logger.debug("Added listener to T-event: "+a,this),this.listeners.tokenEvent[a]||(this.listeners.tokenEvent[a]=[]),this.listeners.tokenEvent[a].push(b)},AnyBoard.TokenManager.onceTokenEvent=function(a,b){AnyBoard.Logger.debug("Added onceListener to T-event: "+a,this),this.listeners.onceTokenEvent[a]||(this.listeners.onceTokenEvent[a]=[]),this.listeners.onceTokenEvent[a].push(b)},AnyBoard.BaseToken=function(a,b,c,d){this.name=a,this.address=b,this.connected=!1,this.device=c,this.listeners={},this.onceListeners={},this.sendQueue=[],this.cache={},this.driver=d||AnyBoard.BaseToken._defaultDriver},AnyBoard.BaseToken._defaultDriver={},AnyBoard.BaseToken.setDefaultDriver=function(a){return a.send&&"function"==typeof a.send?(AnyBoard.BaseToken._defaultDriver=a,!0):(AnyBoard.Logger.warn("Could not find send() on given driver",this),!1)},AnyBoard.BaseToken.prototype.setDriver=function(a){a&&a.send&&"function"==typeof a.send?this.driver=a:AnyBoard.Logger.warn("Could not find send() on given driver",this)},AnyBoard.BaseToken.prototype.isConnected=function(){return this.connected},AnyBoard.BaseToken.prototype.connect=function(a,b){AnyBoard.Logger.debug("Attempting to connect to "+this);var c=this;AnyBoard.TokenManager.driver.connect(c,function(b){AnyBoard.Logger.debug("Connected to "+c),c.connected=!0,c.trigger("connect",{device:c}),a&&a()},function(a){AnyBoard.Logger.debug("Could not connect to "+c+". "+a),c.trigger("disconnect",{device:c}),c.connected=!1,b&&b(a)})},AnyBoard.BaseToken.prototype.disconnect=function(){AnyBoard.TokenManager.driver.disconnect(this),AnyBoard.Logger.debug(""+this+" disconnected",this),this.connected=!1,this.trigger("disconnect",{device:this})},AnyBoard.BaseToken.prototype.trigger=function(a,b){AnyBoard.Logger.debug('Triggered "'+a+'"',this);var c=function(a,b,c){if(a[b])for(var d in a[b])a[b].hasOwnProperty(d)&&a[b][d].apply(null,c)};c(this.listeners,a,[b]),c(this.onceListeners,a,[b]),this.onceListeners[a]=[];var d=this;b&&b.hasOwnProperty("meta-eventType")&&("token-token"==b["meta-eventType"]?b.hasOwnProperty("token")?(c(AnyBoard.TokenManager.listeners.tokenTokenEvent,a,[d,b.token,b]),c(AnyBoard.TokenManager.listeners.onceTokenTokenEvent,a,[d,b.token,b]),AnyBoard.TokenManager.listeners.onceTokenTokenEvent[a]=[]):AnyBoard.warn("Attempting to trigger token-token event type, but missing token option",this):"token"==b["meta-eventType"]?(c(AnyBoard.TokenManager.listeners.tokenEvent,a,[d,b]),c(AnyBoard.TokenManager.listeners.onceTokenEvent,a,[d,b]),AnyBoard.TokenManager.listeners.onceTokenEvent[a]=[]):"token-constraint"==b["meta-eventType"]?b.hasOwnProperty("constraint")?(c(AnyBoard.TokenManager.listeners.tokenConstraintEvent,a,[d,b.constraint,b]),c(AnyBoard.TokenManager.listeners.onceTokenConstraintEvent,a,[d,b.constraint,b]),AnyBoard.TokenManager.listeners.onceTokenConstraintEvent[a]=[]):AnyBoard.warn("Attempting to trigger token-token event type, but missing constraint option",this):AnyBoard.warn("Attempting to trigger invalid event type: "+b["meta-eventType"],this))},AnyBoard.BaseToken.prototype.on=function(a,b){AnyBoard.Logger.debug("Added listener to event: "+a,this),this.listeners[a]||(this.listeners[a]=[]),this.listeners[a].push(b)},AnyBoard.BaseToken.prototype.once=function(a,b){AnyBoard.Logger.debug("Added onceListener to event: "+a,this),this.onceListeners[a]||(this.onceListeners[a]=[]),this.onceListeners[a].push(b)},AnyBoard.BaseToken.prototype.send=function(a,b,c){if(AnyBoard.Logger.debug("Attempting to send with data: "+a,this),this.isConnected())this.driver.send(this,a,b,c);else{AnyBoard.Logger.warn("Is not connected. Attempting to connect first.",this);var d=this;this.connect(function(e){d.send(a,b,c)},function(a){c&&c(a)})}},AnyBoard.BaseToken.prototype.print=function(a,b,c){this.driver.hasOwnProperty("print")?this.driver.print(this,a,b,c):(AnyBoard.Logger.warn("This token has not implemented print",this),c&&c("This token has not implemented print"))},AnyBoard.BaseToken.prototype.getFirmwareName=function(a,b){this.driver.hasOwnProperty("getName")?this.driver.getName(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.warn("This token has not implemented getName",this),b&&b("This token has not implemented getName"))},AnyBoard.BaseToken.prototype.getFirmwareVersion=function(a,b){this.driver.hasOwnProperty("getVersion")?this.driver.getVersion(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.warn("This token has not implemented getVersion",this),b&&b("This token has not implemented getVersion"))},AnyBoard.BaseToken.prototype.getFirmwareUUID=function(a,b){this.driver.hasOwnProperty("getUUID")?this.driver.getUUID(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.warn("This token has not implemented getUUID",this),b&&b("This token has not implemented getUUID"))},AnyBoard.BaseToken.prototype.hasLed=function(a,b){this.driver.hasOwnProperty("hasLed")?this.driver.hasLed(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasLed",this),b&&b("This token has not implemented hasLed"))},AnyBoard.BaseToken.prototype.hasLedColor=function(a,b){this.driver.hasOwnProperty("hasLedColor")?this.driver.hasLedColor(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasLedColor",this),b&&b("This token has not implemented hasLedColor"))},AnyBoard.BaseToken.prototype.hasVibration=function(a,b){this.driver.hasOwnProperty("hasVibration")?this.driver.hasVibration(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasVibration",this),b&&b("This token has not implemented hasVibration"))},AnyBoard.BaseToken.prototype.hasColorDetection=function(a,b){this.driver.hasOwnProperty("hasColorDetection")?this.driver.hasColorDetection(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasColorDetection",this),b&&b("This token has not implemented hasColorDetection"))},AnyBoard.BaseToken.prototype.hasLedScreen=function(a,b){this.driver.hasOwnProperty("hasLedSceen")?this.driver.hasLedScreen(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasLedSceen",this),b&&b("This token has not implemented hasLedSceen"))},AnyBoard.BaseToken.prototype.hasRfid=function(a,b){this.driver.hasOwnProperty("hasRfid")?this.driver.hasRfid(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasRfid",this),b&&b("This token has not implemented hasRfid"))},AnyBoard.BaseToken.prototype.hasNfc=function(a,b){this.driver.hasOwnProperty("hasNfc")?this.driver.hasNfc(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasNfc",this),b&&b("This token has not implemented hasNfc"))},AnyBoard.BaseToken.prototype.hasAccelometer=function(a,b){this.driver.hasOwnProperty("hasAccelometer")?this.driver.hasAccelometer(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasAccelometer",this),b&&b("This token has not implemented hasAccelometer"))},AnyBoard.BaseToken.prototype.hasTemperature=function(a,b){this.driver.hasOwnProperty("hasTemperature")?this.driver.hasTemperature(this,function(b){a&&a(b.value)},b):(AnyBoard.Logger.debug("This token has not implemented hasTemperature",this),b&&b("This token has not implemented hasTemperature"))},AnyBoard.BaseToken.prototype.ledOn=function(a,b,c){this.driver.hasOwnProperty("ledOn")?this.driver.ledOn(this,a,b,c):(AnyBoard.Logger.warn("This token has not implemented ledOn",this),c&&c("This token has not implemented ledOn"))},AnyBoard.BaseToken.prototype.ledBlink=function(a,b,c){this.driver.hasOwnProperty("ledBlink")?this.driver.ledBlink(this,a,b,c):(AnyBoard.Logger.warn("This token has not implemented ledBlink",this),c&&c("This token has not implemented ledBlink"))},AnyBoard.BaseToken.prototype.ledOff=function(a,b){this.driver.hasOwnProperty("ledOff")?this.driver.ledOff(this,a,b):(AnyBoard.Logger.warn("This token has not implemented ledOff",this),b&&b("This token has not implemented ledOff"))},AnyBoard.BaseToken.prototype.toString=function(){return"Token: "+this.name+" ("+this.address+")"},AnyBoard.Logger={threshold:10,debugLevel:0,normalLevel:10,warningLevel:20,errorLevel:30,loggerObject:console,_message:function(a,b,c){var d="AnyBoard ("+a+"): "+b+(c?" ("+c+")":"");(this.threshold<=a||this.errorLevel<=a)&&this.debugLevel<=a&&(a>=this.errorLevel?this.loggerObject.error&&this.loggerObject.error(d):a>=this.warningLevel?this.loggerObject.warn&&this.loggerObject.warn(d):a>=this.normalLevel?this.loggerObject.log&&this.loggerObject.log(d):this.loggerObject.debug&&this.loggerObject.debug(d)),"undefined"!=typeof hyper&&hyper.log(d)},warn:function(a,b){this._message(this.warningLevel,a,b)},error:function(a,b){this._message(this.errorLevel,a,b)},log:function(a,b){this._message(this.normalLevel,a,b)},debug:function(a,b){this._message(this.debugLevel,a,b)},setThreshold:function(a){this.threshold=a}},AnyBoard.Utils={},AnyBoard.Utils._isFunction=function(a){return"function"==typeof a||!1},AnyBoard.Utils._isObject=function(a){var b=typeof a;return"function"===b||"object"===b&&!!a},AnyBoard.Utils._has=function(a,b){return null!=a&&hasOwnProperty.call(a,b)},AnyBoard.Utils._keys=function(a){if(!AnyBoard.Utils._isObject(a))return[];if(Object.keys)return Object.keys(a);var b=[];for(var c in a)AnyBoard.Utils._has(a,c)&&b.push(c);return b},AnyBoard.Utils.isEqual=function(a,b,c,d){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;if(a!==a)return b!==b;var e=typeof a;return"function"!==e&&"object"!==e&&"object"!=typeof b?!1:AnyBoard.Utils._deepEq(a,b,c,d)},AnyBoard.Utils._deepEq=function(a,b,c,d){var e=toString.call(a);if(e!==toString.call(b))return!1;switch(e){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var f="[object Array]"===e;if(!f){if("object"!=typeof a||"object"!=typeof b)return!1;var g=a.constructor,h=b.constructor;if(g!==h&&!(AnyBoard.Utils._isFunction(g)&&g instanceof g&&AnyBoard.Utils._isFunction(h)&&h instanceof h)&&"constructor"in a&&"constructor"in b)return!1}c=c||[],d=d||[];for(var i=c.length;i--;)if(c[i]===a)return d[i]===b;if(c.push(a),d.push(b),f){if(i=a.length,i!==b.length)return!1;for(;i--;)if(!AnyBoard.Utils.isEqual(a[i],b[i],c,d))return!1}else{var j,k=AnyBoard.Utils._keys(a);if(i=k.length,AnyBoard.Utils._keys(b).length!==i)return!1;for(;i--;)if(j=k[i],!AnyBoard.Utils._has(b,j)||!AnyBoard.Utils.isEqual(a[j],b[j],c,d))return!1}return c.pop(),d.pop(),!0};